'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _omniFetch = require('omni-fetch');

var _omniFetch2 = _interopRequireDefault(_omniFetch);

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var setTimeoutPromise = _util2.default.promisify(setTimeout);

function ISTEXFetchRetry(data, feed) {
    if (this.isLast()) {
        return feed.close();
    }
    var after = Number(this.getParam('after', 1000));
    console.log('retry if', data instanceof Error);
    if (data instanceof Error && data.url && data.input) {
        var urlStr = data.url,
            input = data.input,
            target = data.target;

        console.log('retry after', after, urlStr);
        setTimeoutPromise(after).then(function () {
            return (0, _omniFetch2.default)(urlStr);
        }).then(function (response) {
            return response.json();
        }).then(function (json) {
            return feed.send((0, _utils.newValue)(json, target, input));
        }).catch(function (err) {
            err.url = urlStr;
            err.input = data;
            err.target = target;
            feed.send(err);
        });
    }
    return feed.send(data);
}

exports.default = {
    ISTEXFetchRetry: ISTEXFetchRetry
};