'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _stream = require('stream');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ISTEXParseDotCorpus(data, feed) {
    if (this.isLast()) {
        return feed.close();
    }
    var metadata = this.ezs.metaString(data);
    var statement = this.ezs.fromString(data);
    var input = new _stream.PassThrough({ objectMode: true });
    var output = input.pipe(statement).on('data', function (chunk) {
        feed.write((0, _extends3.default)({}, metadata, chunk));
    }).on('error', function (e) {
        feed.write(e);
    }).on('end', function () {
        feed.end();
    });
    (0, _utils.writeTo)(input, metadata, function () {
        return input.end();
    });
}

exports.default = {
    ISTEXParseDotCorpus: ISTEXParseDotCorpus
};