'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _omniFetch = require('omni-fetch');

var _omniFetch2 = _interopRequireDefault(_omniFetch);

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ISTEXRequest(data, feed) {
    if (this.isLast()) {
        return feed.close();
    }

    var sid = this.getParam('sid', 'ezs-istex');
    var size = this.getParam('size', 2000);
    var scroll = this.getParam('duration', '30s');
    var field = this.getParam('output', ['doi']);
    var fields = Array.isArray(field) ? field : [field];
    var output = fields.map(function (e) {
        return (/\w+/.exec(e)[0]
        );
    }).join();
    var location = {
        protocol: 'https:',
        host: 'api.istex.fr',
        pathname: '/document/'
    };
    var parameters = {
        q: data,
        scroll: scroll,
        output: output,
        size: size,
        sid: sid
    };
    var urlObj = _extends({}, location, {
        search: _qs2.default.stringify(parameters)
    });
    var urlStr = _url2.default.format(urlObj);
    console.log('url', urlStr);

    (0, _omniFetch2.default)(urlStr).then(function (response) {
        return response.json();
    }).then(function (json) {
        // 200 001 / 1000 = 200.1
        if (!json.total) {
            return feed.send(new Error('No resuslt.'));
        }
        var scrollId = json.scrollId;

        var scrollUrl = _url2.default.format(_extends({}, location, {
            search: _qs2.default.stringify(_extends({}, parameters, {
                scrollId: scrollId
            }))
        }));
        //            console.log('scrollUrl', scrollUrl);
        var pages = Array(Math.ceil(json.total / size) - 1).map(function () {
            return scrollUrl;
        }).fill(scrollUrl);
        console.log('pages', pages);

        return feed.send(json);
    }).catch(function (err) {
        feed.send(err);
    });
}

exports.default = {
    ISTEXRequest: ISTEXRequest
};