'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _dotProp = require('dot-prop');

var _dotProp2 = _interopRequireDefault(_dotProp);

var _omniFetch = require('omni-fetch');

var _omniFetch2 = _interopRequireDefault(_omniFetch);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ISTEXScroll(data, feed) {
    if (this.isLast()) {
        return feed.close();
    }

    var source = this.getParam('source');
    var target = this.getParam('target');
    var handle = source ? _dotProp2.default.get(data, source) : data;

    if (typeof handle !== 'string') {
        return feed.send(data);
    }
    (0, _omniFetch2.default)(handle).then(function (response) {
        return response.json();
    }).then(function (json) {
        if (json.total === 0) {
            return feed.send(new Error('No result.'));
        }
        if (json.total === undefined) {
            return feed.send(new Error('Unexpected response.'));
        }
        feed.write((0, _utils.newValue)(json, target, data));
        return feed.end();
    }).catch(function (err) {
        feed.send(err);
    });
}

exports.default = {
    ISTEXScroll: ISTEXScroll
};